<?php

namespace Drupal\asc_courses\Commands;

use Consolidation\OutputFormatters\StructuredData\RowsOfFields;
use Drush\Commands\DrushCommands;
use \Drupal\node\Entity\Node;

use \Drupal\asc_courses\AscCoursesApi;
use \Drupal\asc_courses\AscCoursesImporter;

use \Drupal\Core\Database\Database;


/**
 * A Drush commandfile.
 *
 * In addition to this file, you need a drush.services.yml
 * in root of your module, and a composer.json file that provides the name
 * of the services file to use.
 *
 * See these files for an example of injecting Drupal services:
 *   - http://cgit.drupalcode.org/devel/tree/src/Commands/DevelCommands.php
 *   - http://cgit.drupalcode.org/devel/tree/drush.services.yml
 */
class AscCoursesCommands extends DrushCommands {

  public $soip_constant_name = "PANTHEON_SOIP_EIP";
  // public $soip_constant_name = "PANTHEON_SOIP_EIP_PROD";
  
  /**
   * Command description here.
   *
   * @param $arg1
   *   Argument description.
   * @param array $options
   *   An associative array of options whose values come from cli, aliases, config, etc.
   * @option option-name
   *   Description
   * @usage asc_courses-commandName foo
   *   Usage description
   *
   * @command asc_courses:commandName
   * @aliases foo
   */
  public function commandName($arg1, $options = ['option-name' => 'default']) {
    //$this->logger()->success(dt('Achievement unlocked.'));

    $api = new AscCoursesApi();
    $api->processPendingApiData();
    // print_r($api->fetchDorgCourses('D0506'));

    // $api->getAccessToken();
    // $dorg = $api->config->get('asc_courses.dept_org');
    // echo "D-org: $dorg\n";
    // $courses = $api->fetchDorgCourses($dorg);
    
    // module_load_install('asc_courses');
    // $schema = Database::getConnection()->schema();
    // $tables = asc_courses_schema();


    // $importer = new AscCoursesImporter();
    // $importer->debug = 2;
    // $api_response = $importer->loadSubjectDataFromDatabase($arg1);
    // $course_data = $api_response->getCourseCatalogResponse->catalog->course;
    // echo "\n";
    // echo count($course_data) . " courses in $arg1\n\n";

    // foreach ($course_data as $course) {
    //   $eip_id = $course->{'crse-id'};
    //   $subj_abbrev = $course->{'subject'};
    //   $cat_num = $course->{'catalog-nbr'};
    //   $title = $course->{'course-title-long'};
    //   echo "$eip_id - $subj_abbrev - $cat_num - $title\n";      
    // }
    // $importer->fetchAndImportAll();
    
    // $importer->establishApiReferences();
  }


  /**
   * Establish EIP references for course nodes lacking them
   *
   * @param array $options
   *   An associative array of options whose values come from cli, aliases, config, etc.
   * @option option-name
   *   Description
   * @usage asc_courses-link-nodes-to-api
   *   Usage description
   *
   * @command asc_courses:link-nodes-to-api
   * @aliases asc-link-nodes-to-api
   */
  public function linkNodesToApi($options = ['option-name' => 'default']) {
    $importer = new AscCoursesImporter();
    $importer->debug = 2;
    // $importer->fetchAndImportAll();
    // print_r($importer->loadSubjectDataFromDatabase('D0506'));
    $importer->establishApiReferences();
  }

  /**
   * Pull fresh data for all D-Orgs from the API to database
   *
   * @param array $options
   *   An associative array of options whose values come from cli, aliases, config, etc.
   * @option option-name
   *   Description
   * @usage asc_courses-pull-all-dorgs
   *   Usage description
   *
   * @command asc_courses:pull-all-dorgs
   * @aliases asc-pull-all-dorgs
   */
  public function pullAllDorgs($options = ['option-name' => 'default']) {
    $api = new AscCoursesApi();
    $api->debug = 1;

    $dorgs = $api->getDorgList();
    $dorg_numbers = array_keys($dorgs);

    echo "Dorg count: " . count($dorg_numbers) . "\n";

    foreach($dorg_numbers as $dorg_number) {
      
        echo "=== $dorg_number - " . $dorgs[$dorg_number]["name"] . " ===\n";
        $courses = $api->fetchDorgCourses($dorg_number);
        // echo "courses type: " . gettype($courses) . "\n";
        // $courses_vars = get_object_vars($courses);
        // echo "vars: " . print_r(array_keys($courses_vars), true) . "\n";
      
        echo "===================================\n";
    }

    /*
      $dorgs = $dorgs->getDeptOrgInfoResponse->OUT_VP_CATEGORY->OUT_VP_AREA;

      // echo "dorgs type: " . gettype($dorgs) . "\n";
      // $dorg_vars = get_object_vars($dorgs);
      // echo "vars: " . print_r(array_keys($dorg_vars), true) . "\n";

      $dorgs = $dorgs->OUT_VP_COLLEGE->OUT_COLLEGE1;
      // print_r($dorgs);

      // echo "dorgs type: " . gettype($dorgs) . "\n";
      // $dorg_vars = get_object_vars($dorgs);
      // print_r($dorg_vars);
      // echo "vars: " . print_r(array_keys($dorgs), true) . "\n";
    */

    /*
      foreach($dorgs as $dorg) {
        echo "==================\n";
        // echo "dorg type: " . gettype($dorg) . "\n";
        // $dorg_vars = get_object_vars($dorg);
        // echo "dorg vars: " . print_r(array_keys($dorg_vars), true) . "\n";

        echo "COLLEGE1: " . $dorg->COLLEGE1 . "\n";
        echo "COLLEGE1_DESCR: " . $dorg->COLLEGE1_DESCR . "\n\n";


        $out_college2 = $dorg->OUT_COLLEGE2;
        // echo "out_college2 type: " . gettype($out_college2) . "\n";
        // echo "out_college2 keys: " . print_r(array_keys($out_college2), true) . "\n";

        foreach ($out_college2 as $college2) {
          echo "------------\n";
          // echo "college2 type: " . gettype($college2) . "\n";
          // $college2_vars = get_object_vars($college2);
          // echo "college2 vars: " . print_r(array_keys($college2_vars), true) . "\n";

          echo "COLLEGE2: " . $college2->COLLEGE2 . "\n";
          echo "COLLEGE2_DESCR: " . $college2->COLLEGE2_DESCR . "\n\n";

          $out_department = $college2->OUT_DEPARTMENT;
          echo "out_department type: " . gettype($out_department) . "\n";
          $out_department_vars = get_object_vars($out_department);
          echo "out_department vars: " . print_r(array_keys($out_department_vars), true) . "\n";
          echo "------------\n";

        }

        // echo "out_vp_college type: " . gettype($dorg->OUT_VP_COLLEGE) . "\n";
        // $out_vp_college_vars = get_object_vars($dorg->OUT_VP_COLLEGE);
        // echo "vars: " . print_r(array_keys($out_vp_college_vars), true) . "\n";
        echo "==================\n\n";
      }
    */
  }


  /**
   * Process all unprocessed API daata
   *
   * @param array $options
   *   An associative array of options whose values come from cli, aliases, config, etc.
   * @option option-name
   *   Description
   * @usage asc_courses-commandName [count]
   *   Usage description
   *
   * @command asc_courses:processApiData
   * @aliases asc-courses-process-api-data
   */
  public function processApiData($count = null, $options = ['option-name' => 'default']) {
    //$this->logger()->success(dt('Achievement unlocked.'));

    $api = new AscCoursesApi();
    $api->debug = 1;
    if(is_numeric($count)) {
      echo "count argument specified: $count\n";
      $api->processPendingApiData(null, $count);
    }
    else {
      // echo "Count is NOT numeric: $count\n";
      $api->processPendingApiData();
    }
    
  }


  /**
   * Command description here.
   *
   * @param array $options
   *   An associative array of options whose values come from cli, aliases, config, etc.
   * @option option-name
   *   Description
   * @usage asc_courses-class-import
   *   Usage description
   *
   * @command asc_courses:class-import
   * @aliases asc-class-import
   */
  public function classImport($options = ['option-name' => 'default']) {
    // $this->logger()->success(dt('Achievement unlocked.'));

    // Bittrex example
    // $response = \Drupal::httpClient()
    // ->get('https://api.bittrex.com/api/v1.1/public/getmarkets');
    // $json_string = (string) $response->getBody();
    // $json_data = json_decode($json_string);
    // print_r($json_data);

    // return true;

    echo $this->soip_constant_name . ": " . constant($this->soip_constant_name) . "\n";
    

    $config = \Drupal::service('config.factory')->get('asc_courses.settings');
    $consumer_key = $config->get('asc_courses.qa_consumer_key');
    $consumer_secret = $config->get('asc_courses.qa_consumer_secret');
    $dept_org = $config->get('asc_courses.dept_org');
    $bearer_auth = base64_encode("$consumer_key:$consumer_secret");
    echo "consumer key: $consumer_key\n";
    echo "consumer secret: $consumer_secret\n";
    echo "dept_org: $dept_org\n";
    echo "bearer_auth: $bearer_auth\n";



    /*
      // get access token
      $token_response = \Drupal::httpClient()
        ->post($access_token_url, 
            [
              'headers' => [
                'Accept' => 'application/json',
                'Authorization' => "Basic $bearer_auth"
              ],
              'form_params' => [
                'grant_type' => 'client_credentials'
              ]
            ]
      );
      $json_string = (string) $token_response->getBody();
      $json_data = json_decode($json_string);
      print_r($json_data);
      $access_token = json_decode($token_response->getBody())->access_token;
      // echo "access_token: $access_token\n";
    */

    // QA URL
    $access_token_url = 'https://apig-qa.eip.osu.edu/token?grant_type=client_credentials';

    // Production URL
    // $access_token_url = 'https://apig.eip.osu.edu/token?grant_type=client_credentials';

    $access_token_headers = [
      "Accept: application/json",
      "Authorization: Basic $bearer_auth",
    ];

    // Create a "resolve_host" that will point to localhost and resolve externally
    $host = parse_url($access_token_url, PHP_URL_HOST);
    $localhost = "127.0.0.1";
    $resolve_host = array(sprintf("%s:%d:%s", $host, constant($this->soip_constant_name), $localhost));
    echo "\n resolve_host : " . implode($resolve_host) . "\n";

    // $post_data = ["grant_type" => "client_credentials"];

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $access_token_url);
    curl_setopt($ch, CURLOPT_RESOLVE, $resolve_host);
    curl_setopt($ch, CURLOPT_PORT, constant($this->soip_constant_name));
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
    curl_setopt($ch, CURLOPT_POST, true);
    // curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
    curl_setopt($ch, CURLOPT_TIMEOUT, 30);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $access_token_headers);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
    curl_setopt($ch, CURLOPT_VERBOSE, true);
    $access_token_start = microtime(true);
    $access_token_result = curl_exec($ch);
    $access_token_error = curl_error($ch);
    print_r($access_token_error);
    curl_close($ch);
    $access_token_finish = microtime(true);
    $access_token_seconds = $access_token_finish - $access_token_start;

    echo "\n================\nAccess token result: \n";
    print_r($access_token_result);
    echo "\n";
    echo "Access token in $access_token_seconds seconds\n";


    $json_data = json_decode($access_token_result);
    // print_r($json_data);
    $access_token = $json_data->access_token;
    echo "access_token: $access_token\n\n";


    // QA URL
    $course_data_url = "https://apig-qa.eip.osu.edu/crseinfo/1.0.0/getCatalogInfo?campus=COL&acad_org=$dept_org";

    // Production URL
    // $course_data_url = "https://apig.eip.osu.edu/crseinfo/1.0.0/getCatalogInfo?campus=COL&acad_org=$dept_org";
    
    echo "course data url: $course_data_url\n";
    $course_data_headers = [
      "Accept: application/json",
      "Authorization: Bearer $access_token"
    ];


    /*
      // get course data  (httpClient)
      $response = \Drupal::httpClient()
      ->get("https://apig-qa.eip.osu.edu/crseinfo/1.0.0/getCatalogInfo?campus=COL&acad_org=$dept_org", 
              [
                // 'auth' => ['username', 'password'],
                'headers' => [
                  'Accept' => 'application/json',
                  'Authorization' => "Bearer $access_token"
                ]
              ]
      );
    
      $course_json = (string) $response->getBody();
      echo "json length: " . strlen($course_json) . "\n\n";
    */

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $course_data_url);
    curl_setopt($ch, CURLOPT_RESOLVE, $resolve_host);
    curl_setopt($ch, CURLOPT_PORT, constant($this->soip_constant_name));
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
    curl_setopt($ch, CURLOPT_TIMEOUT, 30);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $course_data_headers);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
    // curl_setopt($ch, CURLOPT_VERBOSE, true);
    $course_data_start = microtime(true);
    $course_data_result = curl_exec($ch);
    // print_r($course_data_result);
    $course_data_error = curl_error($ch);
    curl_close($ch);
    $course_data_finish = microtime(true);
    $course_data_seconds = $course_data_finish - $course_data_start;

    echo "Course data length:" . strlen($course_data_result) . "\n";
    echo "Course data in $course_data_seconds seconds\n\n";


    $connection = \Drupal::database();
    $row = [
      'date' => time(),
      'dept_org' => $dept_org,
      'raw_json' => $course_data_result
    ];
    $connection->insert('asc_course_data')->fields($row)->execute();


    $json_data = json_decode($course_data_result);

    // print_r($json_data);
  }

  /**
   * Command description here.
   *
   * @param array $options
   *   An associative array of options whose values come from cli, aliases, config, etc.
   * @option option-name
   *   Description
   * @usage asc_courses-create-courses
   *   Usage description
   *
   * @command asc_courses:create-courses
   * @aliases asc-create-courses
   */
  public function createCourses($options = ['option-name' => 'default']) {
    $importer = new AscCoursesImporter();
    $importer->debug = 2;
    $importer->fetchAndImportAll();

    // $connection = \Drupal::database();
    // $course_info_query = $connection->select('asc_course_data', 'acd')
    //   // ->fields('acd', array('id', 'date', 'dept_org'))
    //   ->fields('acd')
    //   ->orderBy('date', 'DESC')
    //   ->range(0, 1);
    // $course_info_result = $course_info_query->execute();
    // // $result_count = $course_info_result->rowCount();
    // // echo "Rows: $result_count\n";
    // // $rows = $course_info_result->fetchAllAssoc('id', \PDO::FETCH_ASSOC);
    // $row = $course_info_result->fetchAssoc();
    // // print_r($row);
    // $courses_json = $row['raw_json'];
    // // $len = strlen($courses_json);
    // echo "JSON Length:" . strlen($courses_json) . "\n";
    // // echo substr($courses_json, 0, 1024) . "\n\n";
    // $json_data = json_decode($courses_json);
    // // print_r($json_data);
    
    // foreach($json_data->getCourseCatalogResponse->catalog->course as $json_course) {
    //   if($i < 1) {
    //     print_r($json_course);

    //     // look up existing node
    //     $node_query = \Drupal::entityQuery('node')
    //       ->condition('field_eip_id', $json_course->{'crse-id'}, '=');
    //     $existing_node = $node_query->execute();

    //     if(empty($existing_node)) {
    //       // $course_node = Node::create([
    //       $course_node = \Drupal::entityTypeManager()->getStorage('node')->create(array(
    //         'type'        => 'course',
    //         'title'       => $json_course->{'course-title-long'},
    //         // 'field_course_description'  => $json_course->{'descrlong'},
    //         'field_course_number' => [$json_course->{'catalog-nbr'}],
    //         'field_credit_hours' => [$json_course->{'acad-prog'}],
    //         'field_subject_abbreviation' => [$json_course->{'subject'}],
    //         'field_eip_id'                => [$json_course->{'crse-id'}],
    //       ));
    //       $course_node->save();
    //       echo "New course [" . $json_course->{'catalog-nbr'} . "] ";
    //     }
    //     else {
    //       // update existing node
    //       echo "Update existing node!\n\n";
    //       print_r($existing_node);
    //     }

    //     // $i++;
    //   }
    // }
  }

  /**
   * An example of the table output format.
   *
   * @param $nid
   *   ID of the node to be printed.
   * @param array $options An associative array of options whose values come from cli, aliases, config, etc.
   *
   * @field-labels
   *   group: Group
   *   token: Token
   *   name: Name
   * @default-fields group,token,name
   *
   * @command asc_courses:print-node
   * @aliases asc-print-node
   *
   * @filter-default-field name
   * @return \Consolidation\OutputFormatters\StructuredData\RowsOfFields
   */
  public function printNode($nid, $options = ['option-name' => 'default']) {
    $asdf_node = Node::load($nid);
    // print_r($asdf_node);

    $asdf_body = $asdf_node->get('body')->getValue();
    echo "body: " . print_r($asdf_body, true) . "\n";

    $asdf_desc = $asdf_node->get('field_course_description')->getValue();
    echo "description: " . print_r($asdf_desc, true) . "\n";

    $asdf_course_number = $asdf_node->get('field_course_number')->getValue();
    echo "course_number: " . print_r($asdf_course_number, true) . "\n";

    $asdf_credit_hours = $asdf_node->get('field_credit_hours')->getValue();
    echo "credit_hours: " . print_r($asdf_credit_hours, true) . "\n";

    // $asdf_eip_id = $asdf_node->get('field_eip_id')->getValue();
    // echo "eip_id: " . print_r($asdf_eip_id, true) . "\n";

    // $asdf_offered_autumn = $asdf_node->get('field_offered_autumn')->getValue();
    // echo "offered_autumn: " . print_r($asdf_offered_autumn, true) . "\n";

    // $asdf_offered_spring = $asdf_node->get('field_offered_spring')->getValue();
    // echo "offered_spring: " . print_r($asdf_offered_spring, true) . "\n";

    // $asdf_offered_summer = $asdf_node->get('field_offered_summer')->getValue();
    // echo "offered_summer: " . print_r($asdf_offered_summer, true) . "\n";

    // $asdf_subject_abbreviation = $asdf_node->get('field_subject_abbreviation'->getValue();
    // echo "subject_abbreviation: " . print_r($asdf_subject_abbreviation, true) . "\n";

    // $node_entity_type = \Drupal::entityTypeManager()->getDefinition('node');
    // $bundle_key = $node_entity_type = \Drupal::entityTypeManager()->getDefinition('node');
    // echo "bundle key: " . $bundle_key->getKey() . "\n";

  }

  /**
   * An example of the table output format.
   *
   * @param array $options An associative array of options whose values come from cli, aliases, config, etc.
   *
   * @field-labels
   *   group: Group
   *   token: Token
   *   name: Name
   * @default-fields group,token,name
   *
   * @command asc_courses:token
   * @aliases token
   *
   * @filter-default-field name
   * @return \Consolidation\OutputFormatters\StructuredData\RowsOfFields
   */
  public function token($options = ['format' => 'table']) {
    $all = \Drupal::token()->getInfo();
    foreach ($all['tokens'] as $group => $tokens) {
      foreach ($tokens as $key => $token) {
        $rows[] = [
          'group' => $group,
          'token' => $key,
          'name' => $token['name'],
        ];
      }
    }
    return new RowsOfFields($rows);
  }

}
